IRequest = IObject.subClass();

IRequest.create = function(){

	var obj = this.prototype;
	
	obj.init = function(){
		this._action = "";
		this._method = "GET";
		this._data = "";
		this._async = false;
		this._isSend = false;	
		this.RESPONSE_TEXT = 1;
		this.RESPONSE_XML = 2;
		this.RESPONSE_BODY = 3;
		this._response = this.RESPONSE_XML;
		this._http = window.ActiveXObject ? new ActiveXObject("MSXML2.XMLHTTP") : new XMLHttpRequest;
	};
	
	obj.setAction = function (url) {
		this._action = url;
	};
	
	obj.getAction = function () {
		return this._action;
	};
	
	obj.setMethod = function (method) {
		this._method = method;
	};
	
	obj.getMethod = function () {
		return this._method;
	};
	
	obj.setData = function (data) {
		this._data = data;
	};
	
	obj.getData = function () {
		return this._data;
	};
	
	obj.setAsync = function (async) {
		this._async = async;
	};
	
	obj.isAsync = function () {
		return this._async;
	};
	
	obj.getRequest = function (){
		return this._http;
	}
	
	obj.setRequest = function(http){
		this._http = http;
	}
	
	obj.request = function (action, async, method) {
		if(method)
			this._method = method;
		if(action)
			this._action = action;
		if(async)
			this._async = async;
		if(this._http.readyState < 4)
			this._http = window.ActiveXObject ? new ActiveXObject("MSXML2.XMLHTTP") : new XMLHttpRequest;
		try{
			var url = this._action;
			if (IString.isString(this._data)){
				if(url.indexOf("?") > -1)
					url += "?" + encodeURI(this._data);
				else
					url += "&" + encodeURI(this._data);
				this._data = "";
			}
			//ILog.debug(this._action);
			this._http.open (this._method, url, this._async);
			this._http.send (this._data);
			this._isSend = true;
			ILog.info("here is request!");
		}catch (e){
			ILog.error("error:" + e.message, "IRequest.js");
			this._isSend = false;
			return;
		}
	};
	
	obj.response = function (response) {
		var self = this;
		
		if(response){
			this._response = response;
		}
		if(this._isSend){
			this._http.onreadystatechange = function (){
				if(self._http.readyState == 4)
					if(self._http.status < 400){
						callbackHandler();
					}else{
						self._http.abort();
						ILog.error("abort because of wrang status");
					}
			}
		}else{
			return null;
		}
		
		function callbackHandler() {
			ILog.info("empty call back.");
			//alert(self._http.responseText);
		}
		
		function wait(){
			if (self._http.readyState == 4) {
				self._ready = true;
				callbackHandler();
			}
			else {
				self.timeout(wait, 200);
			}
		}
	};
	
	obj.getResponse = function (){
		switch(this._response){
			case this.RESPONSE_TEXT : return this.getRequest().responseText;
			break;
			case this.RESPONSE_BODY : return this.getRequest().responseBody;
			break;
			case this.RESPONSE_XML : return this.getRequest().responseXML;
			break;
		}
	}
	
}

IRequest.create();
