ITree = IModel.subClass();

ITree.create = function(){
	
	var obj = this.prototype;
	
	obj.init = function(){
		obj._xpath = "//itree/item";
		obj._parent = "";
	}
	
	obj.setParent = function (parent){
		obj._parent = parent;
	}
	
	obj.getParent = function (){
		return obj._parent;
	}
	
	obj.setAction = function (url) {
		obj._action = url;
	};
	
	obj.getAction = function () {
		return obj._action;
	};
	
	obj.pull = function (){
		obj._XML = this.response();
		if(!this.isAsync()){
			obj.draw();
		}
	}
	
	obj.draw = function (){
		var items = obj._XML.selectNodes(obj._xpath);
		var html = "";
		var idNodes = obj._XML.selectNodes(obj._xpath + "/id");
		var labelNodes = obj._XML.selectNodes(obj._xpath + "/label");
		var urlNodes = obj._XML.selectNodes(obj._xpath + "/url");
		var hasChildNodes = obj._XML.selectNodes(obj._xpath + "/hasChild");
		for(var i = 0; i < items.length; i++){
			var id = obj.getNodeText(idNodes[i]);
			var label = obj.getNodeText(labelNodes[i]);
			var url = obj.getNodeText(urlNodes[i]);
			var hasChild = obj.getNodeText(hasChildNodes[i]);
			var item = document.createElement("li");
			if(i == items.length - 1)
				item.className = "last";
			if(IString.isEmpty(url)){
				item.innerHTML = label;
			}else{
				var a = document.createElement("a");
				a.href = url;
				a.innerHTML = label;
				item.appendChild(a);
			}
			if(hasChild){
				item.id = "show-" + id;
			}
			/*html += "<li";
			if(hasChild){
				html += " id=\"show-";
				html += id;
				html += "\"";
			}
			if(i == items.length - 1)
				html += " class=\"last\"";
			html += ">";
			if(url && url != ""){
				html += "<a href=\"";
				html += url;
				html += "\">";
			}
			html += label;
			if(url && url != ""){
				html += "</a>";
			}
			if(hasChild){
				html += "<ul id=\"tree-";
				html += id;
				html += "\"></ul>";
			}
			html += "</li>\n";
			*/
		}
		var parent = document.getElementById("tree-" + obj.getParent());
		parent.innerHTML = html;
		return obj._names;
	}
	
	obj.callbackHandler = function (){
		if(obj.getRequest().readyState == 4){
			if(obj.getRequest().status == 200){
				obj._XML = obj.getRequest().responseXML;
				obj.draw();
				//ILog.info(obj.getRequest().readyState + ";" + obj.getRequest().status + "draw here!");
			}else{
				obj.getRequest().abort();
				//ILog.error("??????????", "ITree.js");
			}
		}
	}

}

ITree.create();