ICanvas = IObject.subClass();

ICanvas.panels = [];

ICanvas.createPanel = function (name, width, height, top, left){
	var WIDTH = "260px";
	var HEIGHT = "180px";
	var panel = document.getElementById(name);
	if(!panel){
		panel = document.createElement("div");
		panel.id = name;
		panel.className = "canvas_panel";
		panel.style.position = "absolute";
		panel.style.width = (width ? width : WIDTH);
		panel.style.height = (height ? height : HEIGHT);
		panel.style.left = (left ? left : document.body.clientWidth / 2 - parseFloat(panel.style.width) / 2);
		panel.style.top = (top ? top : document.body.clientHeight / 2 - parseFloat(panel.style.height) / 2);
		var titlebar = document.createElement("div");
		titlebar.style.padding = "2";
		titlebar.className = "canvas_paneltitle";
		titlebar.innerHTML = "title : " + name;
		panel.appendChild(titlebar);
		this.panels[name] = panel;
		var content = document.createElement("div");
		panel.appendChild(content);
		document.body.appendChild(panel);
	}
	return panel;
};

ICanvas.getPanel = function (name){
	return this.panels[name];
}

ICanvas.removePanel = function (name){
	var panel = this.getPanel(name);
	if(panel)
		panel.parentNode.removeChild(panel);
}

ICanvas.splash = function (message){
	var splash = this.createPanel(this.splashName, 250, 140);
	splash.removeChild(splash.firstChild);
	splash.lastChild.innerHTML += message;
}

ICanvas.splashName = "canvas:splash";

ICanvas.splashMessage = function (message){
	var splash = this.getPanel(this.splashName);
	splash.lastChild.innerHTML += message;
}

ICanvas.splashOver = function (){
	var splash = this.getPanel(this.splashName);
	splash.parentNode.removeChild(splash);
}

ICanvas.onDrag = function(evt){
	var event = evt ? evt : window.event;
	
}