ICookie = IObject.subClass();

ICookie.add = function(name, value, expires, path, domain, secure){
	var cookie = document.cookie;
	if(!cookie)
		cookie = "ICookie=";
	cookie += "&" + name + "=" + escape(value);
	this.setCookie(cookie, expires, path, domain, secure);
}

ICookie.get = function(name){
	var cookie = document.cookie;
	var regexp = new RegExp("&" + name + "=[^&]*", "g");
	var result = cookie.match(regexp);
	ILog.debug(result);
	if(!result){
		result = [];
	}
	for(var i = 0; i < result.length; i++){
		result[i] = result[i].replace("&" + name + "=", "");
	}
	return result;
}

ICookie.remove = function(name, value, expires, path, domain, secure){
	var cookie = document.cookie;
	var regexp = new RegExp("&" + name + "=" + value, "g");
	cookie = cookie.replace(regexp, "");
	this.setCookie(cookie, expires, path, domain, secure);
}

ICookie.setCookie = function (cookie, expires, path, domain, secure) { 
	//ILog.debug("cookie set:" + cookie);
	var curCookie = cookie + 
		((expires) ? "; expires=" + expires.toGMTString() : "") + 
		((path) ? "; path=" + path : "") + 
		((domain) ? "; domain=" + domain : "") + 
		((secure) ? "; secure" : ""); 
	document.cookie = curCookie;
	//ILog.info("cookie after set:" + document.cookie);
}

